"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useJustAddedActions = exports.useIsJustAdded = exports.useJustAdded = exports.JustAddedActionsContext = exports.JustAddedContext = exports.JustAddedController = void 0;
const useCtrlActionsCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlActionsCtx"));
const useCtrlCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlCtx"));
const useCtrlState_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlState"));
const react_1 = __importStar(require("react"));
function JustAddedController({ children }) {
    const _s = (0, useCtrlState_1.default)({
        ids: [],
    });
    const _a = (0, react_1.useRef)({});
    _a.current.doJustAdded = (0, react_1.useCallback)((id, timeout = 5000) => {
        _s.current.ids.push(id);
        _s.current.setChanged();
        setTimeout(() => {
            _s.current.ids = _s.current.ids.filter(v => v !== id);
            _s.current.setChanged();
        }, timeout);
    }, [_s]);
    const ctx = (0, useCtrlCtx_1.default)(_s);
    const actionsCtx = (0, useCtrlActionsCtx_1.default)(_a, 'JustAdded');
    return (react_1.default.createElement(exports.JustAddedContext.Provider, { value: ctx },
        react_1.default.createElement(exports.JustAddedActionsContext.Provider, { value: actionsCtx }, children)));
}
exports.JustAddedController = JustAddedController;
exports.default = JustAddedController;
exports.JustAddedContext = react_1.default.createContext(null);
exports.JustAddedActionsContext = react_1.default.createContext(null);
const useJustAdded = () => {
    const { ids } = (0, react_1.useContext)(exports.JustAddedContext);
    return (0, react_1.useMemo)(() => ids, [ids]);
};
exports.useJustAdded = useJustAdded;
const useIsJustAdded = (id) => {
    const { ids } = (0, react_1.useContext)(exports.JustAddedContext);
    const isJustAdded = ids.indexOf(id) >= 0;
    return (0, react_1.useMemo)(() => isJustAdded, [isJustAdded]);
};
exports.useIsJustAdded = useIsJustAdded;
const useJustAddedActions = () => (0, react_1.useContext)(exports.JustAddedActionsContext);
exports.useJustAddedActions = useJustAddedActions;
