import CtrlState from '@thatreact/ctrl/types/CtrlState';
import React, { MutableRefObject } from 'react';
export declare function JustAddedController({ children }: {
    children: any;
}): React.JSX.Element;
export default JustAddedController;
export type JustAddedData = {
    ids: string[];
};
export type JustAddedState = CtrlState<JustAddedData>;
export declare const JustAddedContext: React.Context<JustAddedData>;
export type JustAddedActions = {
    doJustAdded: (v: string, timeout?: number) => void;
};
export type JustAddedActionsState = MutableRefObject<JustAddedActions>;
export declare const JustAddedActionsContext: React.Context<JustAddedActions>;
export declare const useJustAdded: () => string[];
export declare const useIsJustAdded: (id: string) => boolean;
export declare const useJustAddedActions: () => JustAddedActions;
